<?php
include( '../lm_strings.php' );
include( '../lm_prefs.php' );
include( '../lm_settings.php' );
include( '../lm_queries.php' );
include( '../lm_functions.php' );

//--SETTINGS--------------------------------------------------------------------

$lm_path = "../lm.php"; // The path of the MLM script

//--DEBUGING--------------------------------------------------------------------

$mlm_debug = false;

if ( $mlm_debug ) {
	error_reporting(E_ALL); 
	ini_set('display_errors','on');
} else {
	error_reporting(E_ALL ^ E_NOTICE); 
	ini_set('display_errors','off');
}

//--PARAMATER CHECKING----------------------------------------------------------

if ( isset( $_REQUEST['cmd'] ) && !empty( $_REQUEST['cmd'] ) ) { $cmd = $_REQUEST['cmd']; }
if ( isset( $_REQUEST['email'] ) && !empty( $_REQUEST['email'] ) ) { $email_raw = $_REQUEST['email']; $email = htmlentities( $email_raw, ENT_QUOTES, 'UTF-8' ); }
if ( isset( $_REQUEST['firstname'] ) && !empty( $_REQUEST['firstname'] ) ) { $firstname_raw = $_REQUEST['firstname']; $firstname = htmlentities( $firstname_raw, ENT_QUOTES, 'UTF-8' ); }
if ( isset( $_REQUEST['lastname'] ) && !empty( $_REQUEST['lastname'] ) ) { $lastname_raw = $_REQUEST['lastname']; $lastname = htmlentities( $lastname_raw, ENT_QUOTES, 'UTF-8' ); }
if ( isset( $_REQUEST['listcount'] ) && !empty( $_REQUEST['listcount'] ) ) { $listcount = $_REQUEST['listcount']; }

for ( $j = 1; $j <= $listcount; $j++ ) {
	$listid = "list$j";	
	if ( isset( $_REQUEST["$listid"] ) && !empty( $_REQUEST["$listid"] ) ) { 
		if ( $list != "" ) { $list .= ";"; }
		$list .= $_REQUEST["$listid"];
	}
}

//-- INTERNAL PARAMETERS -------------------------------------------------------

$script_file = $_SERVER["SCRIPT_NAME"];
$script_path = Explode( '/', $script_file );
$script_name = $script_path[ count( $script_path ) - 1 ];

//-- GETTING MLM VERSION  ------------------------------------------------------

$apath = "http".(empty($_SERVER['HTTPS'])?'':'s').'://'. $_SERVER['HTTP_HOST'] . str_replace( "html/$script_name", '', $_SERVER['PHP_SELF'] );
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "$apath/lm.php?cmd=getversion&pwd=$admin_password");
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1" );
curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
$lm_ver = curl_exec($ch);
curl_close($ch);

//-- PARAMETER CHECKER & ERROR HANDING -----------------------------------------

session_start();

if ( !isset( $_REQUEST['submit'] ) ) {

	$token = md5( uniqid( rand(), TRUE ) );
	$_SESSION['token'] = $token;
	$_SESSION['token_time'] = time();

} else {

	$errors = array();
	
	if ( $email == "" ) { $errors[] = "Enter your email address in the email address text box"; $wrong['email'] = TRUE; }
	if ( $email !== "" && ( stristr( $email, "." ) == FALSE || stristr( $email, "@" ) == FALSE ) ) { $errors[] = "The e-mail address you have entered is not valid"; $wrong['email'] = TRUE; }
	if ( $firstname == "" ) { $errors[] = "Enter your first name in the first name text box"; $wrong['firstname'] = TRUE; }
	if ( $lastname == "" ) { $errors[] = "Enter your last name in the last name text box"; $wrong['lastname'] = TRUE; }
	
	if ( $list == "" ) { $errors[] = "You have to select a list"; $wrong['list'] = TRUE; }
	
	if ( isset( $_REQUEST['token'] ) && !empty( $_REQUEST['token'] ) ) { $token = $_REQUEST['token']; }
    if ( isset( $_SESSION['token'] ) && $token == $_SESSION['token']) { $tokenisvalid = true; } else { $tokenisvalid = False; }
	if ( time() - $_SESSION['token_time'] > 900 ) { $tokenhasexpired = True; } else { $tokenhasexpired = False; }
	
	if ( !$tokenisvalid ) { $errors[] = "A problem has been detected processing the form data."; $wrong['token'] = TRUE; }
	if ( $tokenhasexpired ) { $errors[] = "The page has expired. Please reload an try again."; $wrong['token'] = TRUE; }
	
	if ( count( $errors ) == 0 ) {
		$url = $lm_path . "?cmd=$cmd&list=$list&email=$email&firstname=$firstname&lastname=$lastname";
		header("Location: $url");
	}
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html lang="en">

	<head>
		<meta http-equiv="content-type" content="text/html;charset=utf-8" />
		<title>Mailing List Subscription - Multiple - Auto</title>
		<meta name="description" content="Mailing List Subscription - Multiple - Auto - Maxprog MLM script lets you handle unsubscribe requests, do click-through tracking and use remote lists" />
		<style type=text/css>
			A:link  { color: #396D84; font-weight: normal; text-decoration: underline }
			A {
				CURSOR: hand; TEXT-DECORATION: none
			}
			A:visited  { color: #396D84; font-weight: normal; text-decoration: underline }
			A:active  { color: #86B82D; text-decoration: underline }
			A:hover   { color: #86B82D; font-weight: normal; text-decoration: underline }
			
			input[type="text"], input[type="password"], textarea {font-weight: bold;}
			select:focus, textarea:focus, input:focus {background-color: #ffffee;}
		</style>
	</head>

	<body>
		<div align="center">
			<br />
			<br />
			<table width="500" border="0" cellspacing="2" cellpadding="0">
				<tr>
					<td height="22">
						<div style="border-radius: 5px; background: #3b6895; padding: 5px; width: 99%; height: auto; margin-left: auto; margin-right: auto; text-align: center">
							<h1 style="font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px;color: white; font-weight: bold; margin-top: 0.00em; margin-bottom: 0.00em;">Mailing List Subscription</h1>
						</div>
					</td>
				</tr>
				<tr bgcolor="white" height="16">
					<td height="16"></td>
				</tr>
				<tr>
					<td>
						<div align="center">
							<form id="FormName" action="<?php echo $script_name; ?>" method="get" name="FormName">
								<input type="hidden" name="token" value="<?php echo $token; ?>" />
								<table width="100%" border="0" cellspacing="2" cellpadding="0">
									<tr height="24">
										<td width="40%" height="24">
											<div align="right">
												<font size="-1" color="#3b6895" face="Verdana"><b>Your E-mail Address</b></font></div>
										</td>
										<td width="15" height="24"></td>
										<td height="24"><input type="text" name="email" size="30" <?php echo " value=\"$email\""; ?> /></td>
										<td height="24"><font size="-2" color="#ff9c9c" face="Geneva,Arial,Helvetica,sans-serif">Required</font></td>
									</tr>
									<tr height="24">
										<td width="40%" height="24">
											<div align="right">
												<font size="-1" color="#3b6895" face="Verdana"><b>Your First Name</b></font></div>
										</td>
										<td width="15" height="24"></td>
										<td height="24"><input type="text" name="firstname" size="30" <?php echo " value=\"$firstname\""; ?> /></td>
										<td height="24"><font size="-2" color="#ff9c9c" face="Geneva,Arial,Helvetica,sans-serif">Required</font></td>
									</tr>
									<tr height="24">
										<td width="40%" height="24">
											<div align="right">
												<font size="-1" color="#3b6895" face="Verdana"><b>Your Last Name</b></font></div>
										</td>
										<td width="15" height="24"></td>
										<td height="24"><input type="text" name="lastname" size="30" <?php echo " value=\"$lastname\""; ?> /></td>
										<td height="24"><font size="-2" color="#ff9c9c" face="Geneva,Arial,Helvetica,sans-serif">Required</font></td>
									</tr>
									<tr height="24">
										<td valign="top" width="40%" height="24">
											<div align="right">
												<font size="-1" color="#3b6895" face="Verdana"><b>Mailing Lists</b></font></div>
										</td>
										<td width="15" height="24"></td>
											<td height="24">
												<?php
												$pwd = $admin_password;
												$ext_list = ".txt";
												$id = 0;
												$lists = explode( "\n", ShowLists() );
												usort( $lists, "SortByName" );									
												foreach ( $lists as $mylist ) {
													list( $name, $count, $date ) = explode( "\t", $mylist );
													if ( trim( $name <> "" ) ) {
														//echo "<option";
														//if ( $name == $list ) { echo " selected=\"selected\""; }
														//echo " value=\"" . $name . ".php\">" . $name . "</option>\n";
														
														$id++;
														$listid = "list$id";
														//echo "<input type=\"checkbox\" name=\"$listid\" value=\"$name\" ";
														//if ( $$listid == "list1" ) { echo "checked=\"checked\"";
														
														//if ( isset( $_REQUEST['list1'] ) && !empty( $_REQUEST['list1'] ) ) { $list1 = $_REQUEST['list1']; }
														echo "<input type=\"checkbox\" name=\"$listid\" value=\"$name\" "; 
														if ( $$listid == $name ) { echo "checked=\"checked\""; }
														echo "/><font size=\"2\" face=\"Arial\"> $name<br /></font>\n";
													}
												}
												echo "<input type=\"hidden\" name=\"listcount\" value=\"$id\" />\n";
												echo "<br />\n";
												function SortByName( $a, $b )
												{
    												//return strcasecmp( $a['name'], $b['name'] ); // Cause a Illegal string offset 'name' error
    												return strcasecmp( $a, $b );
												}
												?>
											</td>
										<td height="24"><font size="-2" color="#ff9c9c" face="Geneva,Arial,Helvetica,sans-serif">Required</font></td>
									</tr>
									<tr height="24">
										<td width="40%" height="24"></td>
										<td width="15" height="24"></td>
										<td height="24"><input type="radio" name="cmd" value="subscribe" <?php if ( $cmd == "" || $cmd == "subscribe" ) { echo "checked=\"checked\""; } ?> /><font size="2" face="Arial"> Subscribe <input type="radio" name="cmd" value="unsubscribe" <?php if ( $cmd == "unsubscribe" ) { echo "checked=\"checked\""; } ?> /> Unsubscribe</font></td>
										<td height="24"></td>
									</tr>
									<tr height="20">
										<td colspan="3" valign="top" height="20"></td>
										<td valign="top" height="20"></td>
									</tr>
									<tr>
										<td width="40%">
											<div align="center"></div>
										</td>
										<td width="15"></td>
										<td>
											<div align="right">
												<font size="-1" face="Verdana"><b><input type="submit" name="submit" value="Submit" /> <input type="reset" value="Clear Form" /></b></font></div>
										</td>
										<td></td>
									</tr>
								</table>
							</form>
						</div>
					</td>
				</tr>
				<tr height="10">
					<td height="10">
						<div align="center">
							<?php

// --- ERROR CHECKING ---

if ( isset( $_REQUEST['submit'] ) ) {
	if ( count( $errors ) > 0) {
		echo "<br />";
		echo "<table width=\"500\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\">";
		echo "<tr bgcolor=\"#ff0000\" height=\"22\">";
		echo "<td height=\"22\">";
		echo "<div align=\"center\">";
		echo "<font color=\"white\" face=\"Verdana, Arial, Helvetica, sans-serif\"><b>Sorry but we can't process your request</b></font></div>";
		echo "</td>";
		echo "</tr>";
		echo "</table>";
		echo "<font size=\"-1\" color=\"red\" face=\"Verdana, Arial, Helvetica, sans-serif\"\>";
		echo "<b/>Please fix the following issues</b/><br />";
		for($i=0; $i<count($errors); $i++){
			echo $errors[$i]."<br />";
		}
	} else if ( count( $successes ) > 0) {
		echo "<font color=\"blue\" face=\"Verdana, Arial, Helvetica, sans-serif\"\>";
		echo "<b/>Your request has been processed successfully:</b/><br />";
		for($i=0; $i<count($successes); $i++){
			echo $successes[$i]."<br />";
		}
	}
}

?></div>
					</td>
				</tr>
				<tr bgcolor="white">
					<td>
						<div align="center">
							<hr />
							<font size="-2" color="#636363" face="Verdana, Arial, Helvetica, sans-serif">Maxprog List Manager v<?php echo $lm_ver; ?> - <a href="https://www.maxprog.com/">Max Programming, LLC</a> - Copyright (c) 2008 - <?php echo date("Y"); ?></font></div>
					</td>
				</tr>
			</table>
			<br />
			<br />
		</div>
	</body>

</html>